package generatorgrafu;

import java.util.ArrayList;
import java.util.Random;
import model.Graf;

public class GeneratorBipartitnihoGrafu {

    public Graf generuj(int pocetUzlu, int pocetHran, int delkaHranyMin, int delkaHranyMax) {
        Graf graf = new Graf(pocetUzlu, pocetHran, delkaHranyMin, delkaHranyMax);

        if (pocetHran >= (pocetUzlu - 1) && pocetHran <= (pocetUzlu * pocetUzlu - pocetUzlu) / 2) { //podminka k ověření, jetli ze zadaných parametrů lze vygenerovat souvislý graf
            for (int i = 0; i < pocetUzlu; i = i + 1) { //for cyklus k zajištění nulové délky všech hran
                for (int j = i; j < pocetUzlu; j = j + 1) {
                    graf.setPrvek(i, j, 0);
                    graf.setPrvek(j, i, 0);
                }
            }

            Random random = new Random();

            ArrayList<Integer> list1 = new ArrayList<>(); //rozdělení uzlů do dvou kategorií, spojení je možné pouze mezi prvky jedné a druhé kategorie
            ArrayList<Integer> list2 = new ArrayList<>();

            int prvniVListu1 = random.nextInt(pocetUzlu);
            int prvniVListu2 = random.nextInt(pocetUzlu);
            while (prvniVListu1 == prvniVListu2) {
                prvniVListu2 = random.nextInt(pocetUzlu);
            }
            list1.add(prvniVListu1);
            list2.add(prvniVListu2);

            for (int i = 0; i < pocetUzlu; i = i + 1) {
                boolean rozhodovac = random.nextBoolean();
                if (i != prvniVListu1 && i != prvniVListu2) {
                    if (rozhodovac) {
                        list1.add(i);
                    } else {
                        list2.add(i);
                    }
                }
            }

            int aktualniPocetHran = 0;

            for (int i = 0; i < list1.size(); i = i + 1) { //zajištění, že každý prvek z 1. seznamu bude spojen alespoň s jedním prvkem druhého seznamu
                int j = list2.get(random.nextInt(list2.size()));
                while (i == j || graf.getPrvek(i, j) != 0) {
                    j = list2.get(random.nextInt(list2.size()));
                }
                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
                graf.setPrvek(j, i, graf.getPrvek(i, j));
                aktualniPocetHran = aktualniPocetHran + 1;
            }

            for (int i = 0; i < list2.size(); i = i + 1) { //zajištění, že každý prvek z 2. seznamu bude spojen alespoň s jedním prvkem druhého seznamu
                if (!jePropojenSListem1(list2.get(i), list1, graf)) {
                    int j = list1.get(random.nextInt(list1.size()));
                    while (i == j || graf.getPrvek(i, j) != 0) {
                        j = list1.get(random.nextInt(list1.size()));
                    }
                    graf.setPrvek(list2.get(i), j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
                    graf.setPrvek(j, list2.get(i), graf.getPrvek(list2.get(i), j));
                    aktualniPocetHran = aktualniPocetHran + 1;
                }
            }

//            while (aktualniPocetHran < pocetHran) {
//                int i = list1.get(random.nextInt(list1.size()));
//                int j = list2.get(random.nextInt(list2.size()));
//                
//                while (i == j || graf.getPrvek(i, j) != 0) {
//                    i = list1.get(random.nextInt(list1.size()));
//                    j = list2.get(random.nextInt(list2.size()));
//                }
//                
//                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
//                graf.setPrvek(j, i, graf.getPrvek(i, j));
//                
//                aktualniPocetHran = aktualniPocetHran + 1;
//            }

        }

        return graf;
    }

    public int randomRozmezi(int min, int max) {
        //random.nextInt(max - min + 1) + min
        Random ran = new Random();
        return ran.nextInt(max - min + 1) + min;

    }

    public boolean jePropojenSListem1(int i, ArrayList list1, Graf graf) {
        for (int j = 0; j < list1.size(); j = j + 1) {
            int prvek = graf.getPrvek(i, j);
            if (i != j) {
                if (prvek != 0) {
                    return true;
                }
            }
        }
        return false;
    }

}
