package generatorgrafu;

import java.util.Random;
import model.Graf;

public class GeneratorSouvislehoGrafu {

    public Graf generuj(int pocetUzlu, int pocetHran, int delkaHranyMin, int delkaHranyMax) {
        Graf graf = new Graf(pocetUzlu, pocetHran, delkaHranyMin, delkaHranyMax);

        if (pocetHran >= (pocetUzlu - 1) && pocetHran <= (pocetUzlu * pocetUzlu - pocetUzlu) / 2) { //podminka k ověření, jetli ze zadaných parametrů lze vygenerovat souvislý graf
            for (int i = 0; i < pocetUzlu; i = i + 1) { //for cyklus k zajištění nulové délky všech hran
                for (int j = i; j < pocetUzlu; j = j + 1) {
                    graf.setPrvek(i, j, 0);
                    graf.setPrvek(j, i, 0);
                }
            }

            Random random = new Random();

            for (int i = 0; i < pocetUzlu - 1; i = i + 1) { //zajištění, že bude graf souvislý, resp. jednokomponentový
                int j = random.nextInt(pocetUzlu - 1 - (i + 1) + 1) + i + 1; //náhodná pozice v poli na i-tém řádku
                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
                graf.setPrvek(j, i, graf.getPrvek(i, j));
            }

            int pocitadloWhile = 0;

            int zbyvaPridatHran = pocetHran - (pocetUzlu - 1);

            for (int index = 0; index < zbyvaPridatHran; index = index + 1) {

                // vyber si náhodný index podle parametrů - pokud na tom indexu je 0 --> přepiš tu 0 vygenerovanou dékou hrany
                //                                        - pokud na tom indexu není 0 --> vygeneruj nový index
                int i = random.nextInt(pocetUzlu - 1);
                int j = random.nextInt(pocetUzlu - 1 - (i + 1) + 1) + i + 1;
                while (graf.getPrvek(i, j) != 0) {
                    i = random.nextInt(pocetUzlu - 1);
                    j = random.nextInt(pocetUzlu - 1 - (i + 1) + 1) + i + 1;
                    pocitadloWhile = pocitadloWhile + 1;
                }
                graf.setPrvek(i, j, random.nextInt(delkaHranyMax - delkaHranyMin + 1) + delkaHranyMin);
                graf.setPrvek(j, i, graf.getPrvek(i, j));

            }

        }

        return graf;
    }
}
