package gui;

import generatorgrafu.GeneratorBipartitnihoGrafu;
import generatorgrafu.GeneratorDvoukomponentovehoGrafu;
import generatorgrafu.GeneratorSouvislehoGrafu;
import generatorgrafu.GeneratorStromu;
import model.DialogoveOknoProUlozeniSouboru;
import model.Graf;
import model.GrafTableModel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.image.BufferedImage;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.WindowConstants;

import org.apache.poi.ss.usermodel.BorderStyle;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.FillPatternType;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.HorizontalAlignment;
import org.apache.poi.ss.usermodel.IndexedColors;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.VerticalAlignment;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class HlavniOkno {

    private JFrame frame;
    private VychodniPanel vychodniPanel;
    private ZapadniPanel zapadniPanel;
    private JSplitPane splitPane;
    private NabidkovaLista menuBar;

    private DialogVolbyPoctuRuznychGrafu dialogVolbyPoctuRuznychGrafu;
    private DialogNastaveni dialogNastaveniVelikosti;

    private Graf aktualneVygenerovanyGraf = new Graf(4);
    private List<Graf> kolekceGrafu = new ArrayList<>();
    private List<TabulkaProGraf> kolekceTabulek = new ArrayList<>();

    private ChangeListener clZmenaSlideruVelikostiPisma;
    private ChangeListener clZmenaSlideruVelikostiTabulky;
    private PropertyChangeListener pclZmenaVeValidovanychPolich;
    private KeyListener klKontrolaValidovanychPoli;
    private ActionListener alGenerovatGraf;
    private ActionListener alVymazatVsechnaPole;
    private ActionListener alRbViceStejnychUloh;
    private ActionListener alRbViceRuznychUloh;
    private ActionListener alUkoncitProgram;
    private ActionListener alUlozitGrafyJakoGif;
    private ActionListener alUlozitGrafyJakoXlsx;
    private ActionListener alUlozitGrafyJakoCsv;
    private ActionListener alUlozitGrafyJakoTxt;
    private ActionListener alOtevritNastaveniVelikosti;
    private ActionListener alRbMalaPismena;
    private ActionListener alRbVelkaPismena;
    private ActionListener alRbCislice;
    private ActionListener alZobrazitInfo;

    private int typZnaceniVrcholu = 0;
    private int pocetGrafuNaGif = 1;
    JFrame druhyFrame = new JFrame();
    TabulkaProGraf zpracovavanaTabulka1;
    TabulkaProGraf zpracovavanaTabulka2;

    public HlavniOkno(int width, int height) {
        frame = new JFrame();
        frame.setLayout(new BorderLayout());
        frame.setTitle("GenGraf");
        frame.setPreferredSize(new Dimension(width, height));
        frame.setLocation(20, 20);
        frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);

        dialogVolbyPoctuRuznychGrafu = new DialogVolbyPoctuRuznychGrafu(frame);
        dialogNastaveniVelikosti = new DialogNastaveni(frame);
        vychodniPanel = new VychodniPanel(kolekceGrafu, aktualneVygenerovanyGraf, kolekceTabulek, dialogNastaveniVelikosti);
        zapadniPanel = new ZapadniPanel();

        vytvorListenery();

        zapadniPanel.getPanelGenerovatGraf().getBtnGenerovatGrafy().addActionListener(alGenerovatGraf);
        zapadniPanel.getPanelGenerovatGraf().getBtnVymazatHodnoty().addActionListener(alVymazatVsechnaPole);

        dialogNastaveniVelikosti.getVtpVelikostPisma().addPropertyChangeListener(pclZmenaVeValidovanychPolich);
        dialogNastaveniVelikosti.getVtpVelikostPisma().addKeyListener(klKontrolaValidovanychPoli);
        dialogNastaveniVelikosti.getSliderVelikostPisma().addChangeListener(clZmenaSlideruVelikostiPisma);
        dialogNastaveniVelikosti.getVtpVelikostTabulky().addPropertyChangeListener(pclZmenaVeValidovanychPolich);
        dialogNastaveniVelikosti.getVtpVelikostTabulky().addKeyListener(klKontrolaValidovanychPoli);
        dialogNastaveniVelikosti.getSliderVelikostTabulky().addChangeListener(clZmenaSlideruVelikostiTabulky);

        //NabidkovaLista menuBar
        menuBar = new NabidkovaLista();
        menuBar.getRbViceStejnychUloh().addActionListener(alRbViceStejnychUloh);
        menuBar.getRbViceRuznychUloh().addActionListener(alRbViceRuznychUloh);
        menuBar.getMenuPolozkaUkoncit().addActionListener(alUkoncitProgram);
        menuBar.getMenuPolozkaUlozitJakoGif().addActionListener(alUlozitGrafyJakoGif);
        menuBar.getMenuPolozkaUlozitJakoXlsx().addActionListener(alUlozitGrafyJakoXlsx);
        menuBar.getMenuPolozkaUlozitJakoCsv().addActionListener(alUlozitGrafyJakoCsv);
        menuBar.getMenuPolozkaUlozitJakoTxt().addActionListener(alUlozitGrafyJakoTxt);
        menuBar.getMenuPolozkaNastavitVelikosti().addActionListener(alOtevritNastaveniVelikosti);
        menuBar.getRbVrcholyMalaPismena().addActionListener(alRbMalaPismena);
        menuBar.getRbVrcholyVelkaPismena().addActionListener(alRbVelkaPismena);
        menuBar.getRbVrcholyCislice().addActionListener(alRbCislice);
        menuBar.getMenuPolozkaInformace().addActionListener(alZobrazitInfo);

        frame.add(menuBar, BorderLayout.NORTH);
        //konec NabidkovaLista menuBar

        //JSplitPane splitPane
        splitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT, zapadniPanel.getScrollPaneProZapadniPanel(), vychodniPanel.getScrollPaneProVychodniPanel());
        splitPane.setOneTouchExpandable(false);
        splitPane.setDividerLocation(350);
        frame.add(splitPane);
        //konec JSplitPane splitPane

        frame.getRootPane().setDefaultButton(zapadniPanel.getPanelGenerovatGraf().getBtnGenerovatGrafy());
        frame.pack();
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);

    }

    private TabulkaProGraf dejGrafDoTabulky(int i) {
        TabulkaProGraf zpracovavanaTabulka = new TabulkaProGraf(new GrafTableModel(kolekceGrafu.get(i), typZnaceniVrcholu), dialogNastaveniVelikosti.getHodnotaVtpVelikostPisma(), dialogNastaveniVelikosti.getHodnotaVtpVelikostTabulky());
        zpracovavanaTabulka.vycentrujHodnotyVTabulce();
        return zpracovavanaTabulka;
    }

    private void aktualizujKolekciTabulek() {
        try {
            vychodniPanel.getPanelProGrafy().removeAll();
            kolekceTabulek.clear();

            for (int i = 0; i < kolekceGrafu.size(); i = i + 1) {
                TabulkaProGraf zpracovavanaTabulka = new TabulkaProGraf(new GrafTableModel(kolekceGrafu.get(i), typZnaceniVrcholu), dialogNastaveniVelikosti.getHodnotaVtpVelikostPisma(), dialogNastaveniVelikosti.getHodnotaVtpVelikostTabulky());
                zpracovavanaTabulka.vycentrujHodnotyVTabulce();
                vychodniPanel.getPanelProGrafy().add(zpracovavanaTabulka);
                kolekceTabulek.add(zpracovavanaTabulka);
                if (i != kolekceGrafu.size() - 1) {
                    vychodniPanel.getPanelProGrafy().add(Box.createRigidArea(new Dimension(1, 15))).setBackground(Color.BLACK);
                }
            }

            vychodniPanel.revalidate();

        } catch (NumberFormatException nfe) {

        }
    }

    private void vytvorListenery() {
        pclZmenaVeValidovanychPolich = new PropertyChangeListener() {
            @Override
            public void propertyChange(PropertyChangeEvent evt) {
                try {
                    aktualizujKolekciTabulek();
                } catch (NumberFormatException nfe) {

                }
            }
        };

        clZmenaSlideruVelikostiPisma = new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                dialogNastaveniVelikosti.getVtpVelikostPisma().setValue(dialogNastaveniVelikosti.getSliderVelikostPisma().getValue());
            }
        };

        clZmenaSlideruVelikostiTabulky = new ChangeListener() {
            @Override
            public void stateChanged(ChangeEvent e) {
                dialogNastaveniVelikosti.getVtpVelikostTabulky().setValue(dialogNastaveniVelikosti.getSliderVelikostTabulky().getValue());
            }
        };

        klKontrolaValidovanychPoli = new KeyAdapter() {
            @Override
            public void keyPressed(KeyEvent e) {
                if (e.getKeyCode() == KeyEvent.VK_ENTER) {
                    try {
                        if (Integer.parseInt(dialogNastaveniVelikosti.getVtpVelikostPisma().getText()) < dialogNastaveniVelikosti.getSliderVelikostPisma().getMinimum()) {
                            dialogNastaveniVelikosti.getVtpVelikostPisma().setValue(dialogNastaveniVelikosti.getSliderVelikostPisma().getMinimum());
                        }
                        if (Integer.parseInt(dialogNastaveniVelikosti.getVtpVelikostPisma().getText()) > dialogNastaveniVelikosti.getSliderVelikostPisma().getMaximum()) {
                            dialogNastaveniVelikosti.getVtpVelikostPisma().setValue(dialogNastaveniVelikosti.getSliderVelikostPisma().getMaximum());
                        }
                        dialogNastaveniVelikosti.getSliderVelikostPisma().setValue(Integer.parseInt(dialogNastaveniVelikosti.getVtpVelikostPisma().getText()));

                        if (Integer.parseInt(dialogNastaveniVelikosti.getVtpVelikostTabulky().getText()) < dialogNastaveniVelikosti.getSliderVelikostTabulky().getMinimum()) {
                            dialogNastaveniVelikosti.getVtpVelikostTabulky().setValue(dialogNastaveniVelikosti.getSliderVelikostTabulky().getMinimum());
                        }
                        if (Integer.parseInt(dialogNastaveniVelikosti.getVtpVelikostTabulky().getText()) > dialogNastaveniVelikosti.getSliderVelikostTabulky().getMaximum()) {
                            dialogNastaveniVelikosti.getVtpVelikostTabulky().setValue(dialogNastaveniVelikosti.getSliderVelikostTabulky().getMaximum());
                        }
                        dialogNastaveniVelikosti.getSliderVelikostTabulky().setValue(Integer.parseInt(dialogNastaveniVelikosti.getVtpVelikostTabulky().getText()));

                    } catch (NumberFormatException nfe) {

                    }
                }
            }
        };

        alGenerovatGraf = new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                try {
                    int index = 0;
                    boolean pokracovat = true;

                    int pocetGrafuJednohoTypu = Integer.parseInt(zapadniPanel.getPanelPocetGrafuJednohoTypu().getVtpPocetGrafu().getText());
                    for (int i = 0; i < pocetGrafuJednohoTypu; i = i + 1) {
                        for (int k = 0; k < zapadniPanel.getSeznamKoster().size(); k = k + 1) {
                            Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpPocetUzlu().getText());
                            Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpPocetHran().getText());
                            Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpDelkaHranyMin().getText());
                            Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpDelkaHranyMax().getText());
                        }
                    }

                    while (pokracovat && index < pocetGrafuJednohoTypu) {
                        int k = 0;
                        while (pokracovat && k < zapadniPanel.getSeznamKoster().size()) {
                            int pocetUzlu = Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpPocetUzlu().getText());
                            int pocetHran = Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpPocetHran().getText());
                            int delkaHranyMin = Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpDelkaHranyMin().getText());
                            int delkaHranyMax = Integer.parseInt(zapadniPanel.getSeznamKoster().get(k).getVtpDelkaHranyMax().getText());

                            if (pocetUzlu < 1 || pocetUzlu > 26) {
                                if (zapadniPanel.getSeznamKoster().size() == 1) {
                                    JOptionPane.showMessageDialog(null, "Počet uzlů generovaného grafu může být minimálně 1, maximálně 26.", "Chyba", JOptionPane.ERROR_MESSAGE);
                                } else {
                                    JOptionPane.showMessageDialog(null, "Graf " + (k + 1) + ". typu:\nPočet uzlů generovaného grafu může být minimálně 1, maximálně 26.", "Graf " + (k + 1) + ". typu: chyba", JOptionPane.ERROR_MESSAGE);
                                    pokracovat = false;
                                    kolekceGrafu.clear();
                                    kolekceTabulek.clear();
                                    break;
                                }
                            } else {
                                if (pocetHran > (pocetUzlu * (pocetUzlu - 1)) / 2) {
                                    if (zapadniPanel.getSeznamKoster().size() == 1) {
                                        JOptionPane.showMessageDialog(null, "Počet hran nemůže být vyšší, než by měl kompletní graf s daným počtem uzlů.", "Chyba", JOptionPane.ERROR_MESSAGE);
                                    } else {
                                        JOptionPane.showMessageDialog(null, "Graf " + (k + 1) + ". typu:\nPočet hran nemůže být vyšší, než by měl kompletní graf s daným počtem uzlů.", "Graf " + (k + 1) + ". typu: chyba", JOptionPane.ERROR_MESSAGE);
                                        pokracovat = false;
                                        kolekceGrafu.clear();
                                        kolekceTabulek.clear();
                                        break;
                                    }
                                } else {
                                    if (delkaHranyMin > delkaHranyMax) {
                                        if (zapadniPanel.getSeznamKoster().size() == 1) {
                                            JOptionPane.showMessageDialog(null, "Minimální délka hrany musí být menší nebo rovna maximální délce hrany.", "Chyba", JOptionPane.ERROR_MESSAGE);
                                        } else {
                                            JOptionPane.showMessageDialog(null, "Graf " + (k + 1) + ". typu:\nMinimální délka hrany musí být menší nebo rovna maximální délce hrany.", "Graf " + (k + 1) + ". typu: chyba", JOptionPane.ERROR_MESSAGE);
                                            pokracovat = false;
                                            kolekceGrafu.clear();
                                            kolekceTabulek.clear();
                                            break;
                                        }
                                    } else {
                                        switch (zapadniPanel.getSeznamKoster().get(k).getCmbTypGrafu().getSelectedIndex()) {
                                            case 0: //souvislý graf
                                                if (pocetHran >= (pocetUzlu - 1) && pocetHran <= (pocetUzlu * pocetUzlu - pocetUzlu / 2)) {
                                                    vychodniPanel.getPanelProGrafy().removeAll();
                                                    if (index == 0 && k == 0) {
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                    }
                                                    aktualneVygenerovanyGraf = new GeneratorSouvislehoGrafu().generuj(pocetUzlu, pocetHran, delkaHranyMin, delkaHranyMax);
                                                    kolekceGrafu.add(aktualneVygenerovanyGraf);
                                                } else {
                                                    if (zapadniPanel.getSeznamKoster().size() == 1) {
                                                        JOptionPane.showMessageDialog(null, "Ze zadaných parametrů nelze vygenerovat souvislý graf.", "Chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    } else {
                                                        JOptionPane.showMessageDialog(null, "Graf " + (k + 1) + ". typu:\nZe zadaných parametrů nelze vygenerovat souvislý graf.", "Graf " + (k + 1) + ". typu: chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    }
                                                }
                                                break;

                                            case 1: //strom
                                                if (pocetHran == pocetUzlu - 1) {
                                                    vychodniPanel.getPanelProGrafy().removeAll();
                                                    if (index == 0 && k == 0) {
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                    }
                                                    aktualneVygenerovanyGraf = new GeneratorStromu().generuj(pocetUzlu, pocetHran, delkaHranyMin, delkaHranyMax);
                                                    kolekceGrafu.add(aktualneVygenerovanyGraf);
                                                } else {
                                                    if (zapadniPanel.getSeznamKoster().size() == 1) {
                                                        JOptionPane.showMessageDialog(null, "Ze zadaných parametrů nelze vygenerovat strom.", "Chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    } else {
                                                        JOptionPane.showMessageDialog(null, "Graf " + (k + 1) + ". typu:\nZe zadaných parametrů nelze vygenerovat strom.", "Graf " + (k + 1) + ". typu: chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    }
                                                }
                                                break;

                                            case 2: //bipartitní graf
                                                vychodniPanel.getPanelProGrafy().removeAll();
                                                if (index == 0 && k == 0) {
                                                    kolekceGrafu.clear();
                                                    kolekceTabulek.clear();
                                                }
                                                if ((pocetHran >= (pocetUzlu - 1)) && (pocetHran <= Math.floor(pocetUzlu / 2) * Math.ceil(pocetUzlu / 2))) {
                                                    aktualneVygenerovanyGraf = new GeneratorBipartitnihoGrafu().generuj(pocetUzlu, pocetHran, delkaHranyMin, delkaHranyMax);
                                                    kolekceGrafu.add(aktualneVygenerovanyGraf);
                                                } else {
                                                    if (zapadniPanel.getSeznamKoster().size() == 1) {
                                                        JOptionPane.showMessageDialog(null, "Ze zadaných parametrů nelze vygenerovat bipartitní graf.", "Chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    } else {
                                                        JOptionPane.showMessageDialog(null, "Graf " + (k + 1) + ". typu:\nZe zadaných parametrů nelze vygenerovat bipartitní graf.", "Graf " + (k + 1) + ". typu: chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    }
                                                }
                                                break;

                                            case 3: //dvoukomponentový graf
                                                vychodniPanel.getPanelProGrafy().removeAll();
                                                if (index == 0 && k == 0) {
                                                    kolekceGrafu.clear();
                                                    kolekceTabulek.clear();
                                                }
                                                if ((pocetHran >= (pocetUzlu - 2)) && (pocetHran <= ((pocetUzlu - 1) * (pocetUzlu - 2)) / 2)) {
                                                    aktualneVygenerovanyGraf = new GeneratorDvoukomponentovehoGrafu().generuj(pocetUzlu, pocetHran, delkaHranyMin, delkaHranyMax);
                                                    kolekceGrafu.add(aktualneVygenerovanyGraf);
                                                } else {
                                                    if (zapadniPanel.getSeznamKoster().size() == 1) {
                                                        JOptionPane.showMessageDialog(null, "Ze zadaných parametrů nelze vygenerovat dvoukomponentový graf.", "Chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    } else {
                                                        JOptionPane.showMessageDialog(null, "Graf " + (k + 1) + ". typu:\nZe zadaných parametrů nelze vygenerovat dvoukomponentový graf.", "Graf " + (k + 1) + ". typu: chyba", JOptionPane.ERROR_MESSAGE);
                                                        pokracovat = false;
                                                        kolekceGrafu.clear();
                                                        kolekceTabulek.clear();
                                                        break;
                                                    }
                                                }
                                                break;
                                        }
                                    }
                                }

                            }
                            k = k + 1;
                        }
                        index = index + 1;
                    }
                    aktualizujKolekciTabulek();
                    vychodniPanel.revalidate();

                } catch (NumberFormatException nfe) {
                    JOptionPane.showMessageDialog(null, "Vyplňte prosím všechna vstupní data.", "Nevyplněná vstupní data", JOptionPane.ERROR_MESSAGE);
                }
            }

        };

        alVymazatVsechnaPole = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                zapadniPanel.getPanelPocetGrafuJednohoTypu().getVtpPocetGrafu().setText("3");
                for (int i = 0; i < zapadniPanel.getSeznamKoster().size(); i = i + 1) {
                    zapadniPanel.getSeznamKoster().get(i).getVtpPocetUzlu().setText("8");
                    zapadniPanel.getSeznamKoster().get(i).getVtpPocetHran().setText("12");
                    zapadniPanel.getSeznamKoster().get(i).getVtpDelkaHranyMin().setText("1");
                    zapadniPanel.getSeznamKoster().get(i).getVtpDelkaHranyMax().setText("1");
                }

//                zapadniPanel.getPanelPocetGrafuJednohoTypu().getVtpPocetGrafu().setText("");
//                for (int i = 0; i < zapadniPanel.getSeznamKoster().size(); i = i + 1) {
//                    zapadniPanel.getSeznamKoster().get(i).getVtpPocetUzlu().setText("");
//                    zapadniPanel.getSeznamKoster().get(i).getVtpPocetHran().setText("");
//                    if (zapadniPanel.getSeznamKoster().get(i).getCbOhodnoceniGrafu().isSelected()) {
//                        zapadniPanel.getSeznamKoster().get(i).getVtpDelkaHranyMin().setText("");
//                        zapadniPanel.getSeznamKoster().get(i).getVtpDelkaHranyMax().setText("");
//                    }
//                }
            }
        };

        alRbViceStejnychUloh = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                zapadniPanel.getPanelPocetGrafuJednohoTypu().getLblPocetGrafu().setText("Počet grafů:");
                zapadniPanel.getPanelPocetGrafuJednohoTypu().getVtpPocetGrafu().setText("");
                zapadniPanel.removeAll();
                zapadniPanel.pridejPanelPocetGrafuJednohoTypu();
                zapadniPanel.getSeznamKoster().clear();
                zapadniPanel.getSeznamKoster().add(new KostraZadaniGrafu());
                for (int i = 0; i < zapadniPanel.getSeznamKoster().size(); i = i + 1) {
                    zapadniPanel.getSeznamKoster().get(i).setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.BLACK), "Graf:"));
                    zapadniPanel.add(zapadniPanel.getSeznamKoster().get(i));
                }
                zapadniPanel.pridejPanelGenerovatGraf();
                frame.getRootPane().setDefaultButton(zapadniPanel.getPanelGenerovatGraf().getBtnGenerovatGrafy());
                zapadniPanel.revalidate();
            }
        };

        alRbViceRuznychUloh = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {

                dialogVolbyPoctuRuznychGrafu.setLocationRelativeTo(frame);
                dialogVolbyPoctuRuznychGrafu.setVisible(true);

                String s = dialogVolbyPoctuRuznychGrafu.getZadanaHodnota();
                if (s != null) {
                    try {
                        int pocetRuznychTypuGrafu = Integer.valueOf(s);
                        pocetGrafuNaGif = pocetRuznychTypuGrafu;

                        zapadniPanel.getPanelPocetGrafuJednohoTypu().getLblPocetGrafu().setText("Počet sérií grafů:");
                        zapadniPanel.getPanelPocetGrafuJednohoTypu().getVtpPocetGrafu().setText("");
                        zapadniPanel.removeAll();
                        zapadniPanel.pridejPanelPocetGrafuJednohoTypu();
                        zapadniPanel.getSeznamKoster().clear();

                        for (int i = 0; i < pocetRuznychTypuGrafu; i = i + 1) {
                            zapadniPanel.getSeznamKoster().add(new KostraZadaniGrafu());
                            zapadniPanel.getSeznamKoster().get(i).setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.BLACK), (i + 1) + ". graf:"));
                            if (i != 0) {
                                zapadniPanel.add(Box.createRigidArea(new Dimension(1, 15)));
                            }
                            zapadniPanel.add(zapadniPanel.getSeznamKoster().get(i));
                        }
                        zapadniPanel.pridejPanelGenerovatGraf();
                        frame.getRootPane().setDefaultButton(zapadniPanel.getPanelGenerovatGraf().getBtnGenerovatGrafy());

                        zapadniPanel.revalidate();

                    } catch (NumberFormatException nfe) {
                        menuBar.getRbViceStejnychUloh().setSelected(true);
                        menuBar.getRbViceRuznychUloh().setSelected(false);
                    }
                } else {
                    menuBar.getRbViceStejnychUloh().setSelected(true);
                    menuBar.getRbViceRuznychUloh().setSelected(false);
                }
            }
        };

        alUkoncitProgram = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                System.exit(0);
            }
        };

        alUlozitGrafyJakoGif = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                ulozGrafJako(".gif");
            }
        };

        alUlozitGrafyJakoXlsx = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                ulozGrafJako(".xlsx");
            }
        };

        alUlozitGrafyJakoCsv = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                ulozGrafJako(".csv");
            }
        };

        alUlozitGrafyJakoTxt = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                ulozGrafJako(".txt");
            }
        };

        alOtevritNastaveniVelikosti = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                dialogNastaveniVelikosti.setVisible(true);
            }
        };

        alRbMalaPismena = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                typZnaceniVrcholu = 0;
                aktualizujKolekciTabulek();
            }
        };

        alRbVelkaPismena = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                typZnaceniVrcholu = 1;
                aktualizujKolekciTabulek();
            }
        };

        alRbCislice = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                typZnaceniVrcholu = 2;
                aktualizujKolekciTabulek();
            }
        };

        alZobrazitInfo = new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String zprava = "© Michal Voda, FIM UHK, 2019";
                JOptionPane.showMessageDialog(null, zprava, "Informace", JOptionPane.INFORMATION_MESSAGE);
            }
        };

    }

    public void ulozGrafJako(String format) {
        JFileChooser dialogoveOkno = new DialogoveOknoProUlozeniSouboru(format);

        //přednastavení názvu ukládaného souboru
        dialogoveOkno.setSelectedFile(new File("graf"));

        //nastavení, které soubory a složky jsou zobrazovány v dialogovém okně pro uložení souborů (nastevení filtru souborů)
        dialogoveOkno.setFileFilter(new FileFilter() {
            @Override
            public boolean accept(File f) {
                return (f.isDirectory() || f.getName().endsWith(format)); //je akceptována složka nebo soubor s danou příponou
            }

            @Override
            public String getDescription() { //nastavení popisku filtru
                switch (format) {
                    case ".gif":
                        return "GIF (*.gif)";
                    case ".xlsx":
                        return "Sešit aplikace Exel (*.xlsx)";
                    case ".csv":
                        return "CSV (*.csv)";
                    case ".txt":
                        return "Textové dokumenty (*.txt)";
                    default:
                        return null;
                }
            }
        });

        if (dialogoveOkno.showSaveDialog(frame) == JFileChooser.APPROVE_OPTION) {

            String nazevSouboruSCestou = dialogoveOkno.getSelectedFile().getAbsolutePath();
            if (nazevSouboruSCestou.endsWith(format)) {
                nazevSouboruSCestou = nazevSouboruSCestou.substring(0, nazevSouboruSCestou.length() - 4);
            }

            switch (format) {
                case ".gif":
                    ulozGrafJakoGif(nazevSouboruSCestou);
                    break;
                case ".xlsx":
                    ulozGrafJakoXlsx(nazevSouboruSCestou);
                    break;
                case ".csv":
                    ulozGrafJakoCsv(nazevSouboruSCestou);
                    break;
                case ".txt":
                    ulozGrafJakoTxt(nazevSouboruSCestou);
                    break;
            }

        }

    }

    public void ulozGrafJakoGif(String nazevSouboruSCestou) {
        try {
            int j = 1;

            if (menuBar.getRbViceRuznychUloh().isSelected()) {

                int vyskaPomocnehoPanelu = 0;
                for (int i = 0; i < pocetGrafuNaGif; i = i + 1) {
                    vyskaPomocnehoPanelu = vyskaPomocnehoPanelu + (kolekceGrafu.get(i).getPocetUzlu() + 1) * dialogNastaveniVelikosti.getHodnotaVtpVelikostTabulky();
                }
                vyskaPomocnehoPanelu = vyskaPomocnehoPanelu + (pocetGrafuNaGif + 1) * 15;

                int sirkaPomocnehoPanelu = 0;
                for (int i = 0; i < pocetGrafuNaGif; i = i + 1) {
                    if (sirkaPomocnehoPanelu < (kolekceGrafu.get(i).getPocetUzlu() + 1) * dialogNastaveniVelikosti.getHodnotaVtpVelikostTabulky()) {
                        sirkaPomocnehoPanelu = (kolekceGrafu.get(i).getPocetUzlu() + 1) * dialogNastaveniVelikosti.getHodnotaVtpVelikostTabulky();
                    }
                }
                sirkaPomocnehoPanelu = sirkaPomocnehoPanelu + 30;

                JFrame pomFrame = new JFrame();
                pomFrame.setSize(new Dimension(sirkaPomocnehoPanelu + 50, vyskaPomocnehoPanelu + 50));
                pomFrame.setLayout(new BorderLayout());
                JPanel panelPodHlavnim = new JPanel();

                for (int i = 0; i < kolekceTabulek.size(); i = i + pocetGrafuNaGif) {
                    JPanel pomocnyPanel = new JPanel();
                    pomocnyPanel.setLayout(new BoxLayout(pomocnyPanel, BoxLayout.Y_AXIS));
                    pomocnyPanel.setBackground(Color.WHITE);
                    pomocnyPanel.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
                    pomocnyPanel.setSize(new Dimension(sirkaPomocnehoPanelu, vyskaPomocnehoPanelu));

                    for (int k = 0; k < pocetGrafuNaGif; k = k + 1) {
                        pomocnyPanel.add(dejGrafDoTabulky(i + k));
                        if (k != pocetGrafuNaGif - 1) {
                            pomocnyPanel.add(Box.createRigidArea(new Dimension(1, 15)));
                        }
                    }
                    panelPodHlavnim.add(pomocnyPanel);
                    pomFrame.add(panelPodHlavnim, BorderLayout.CENTER);
                    pomFrame.setVisible(true);
                    pomFrame.dispose();

                    BufferedImage ulozitelnyGraf = new BufferedImage(sirkaPomocnehoPanelu, vyskaPomocnehoPanelu, BufferedImage.TYPE_INT_RGB);
                    pomocnyPanel.paint(ulozitelnyGraf.createGraphics());

                    if (kolekceTabulek.size() != 1) {
                        File pomocnySoubor;
                        while (Boolean.TRUE) {
                            pomocnySoubor = new File(nazevSouboruSCestou + " (" + j + ")" + ".gif");
                            if (pomocnySoubor.exists()) {
                                j = j + 1;
                            } else {
                                break;
                            }
                        }
                        ImageIO.write(ulozitelnyGraf, "gif", new File(nazevSouboruSCestou + " (" + j + ")" + ".gif"));

                        j = j + 1;
                    } else {
                        ImageIO.write(ulozitelnyGraf, "gif", new File(nazevSouboruSCestou + ".gif"));
                    }
                    aktualizujKolekciTabulek();

                }

            } else {
                for (int i = 0; i < kolekceTabulek.size(); i = i + 1) {

                    BufferedImage ulozitelnyGraf = new BufferedImage(kolekceTabulek.get(i).getSize().width, kolekceTabulek.get(i).getSize().height, BufferedImage.TYPE_BYTE_GRAY);
                    kolekceTabulek.get(i).paint(ulozitelnyGraf.createGraphics());

                    if (kolekceTabulek.size() != 1) {
                        File pomocnySoubor;
                        while (Boolean.TRUE) {
                            pomocnySoubor = new File(nazevSouboruSCestou + " (" + j + ")" + ".gif");
                            if (pomocnySoubor.exists()) {
                                j = j + 1;
                            } else {
                                break;
                            }
                        }
                        ImageIO.write(ulozitelnyGraf, "gif", new File(nazevSouboruSCestou + " (" + j + ")" + ".gif"));

                        j = j + 1;
                    } else {
                        ImageIO.write(ulozitelnyGraf, "gif", new File(nazevSouboruSCestou + ".gif"));
                    }
                }
            }

        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Uložení výstupu se nezdařilo.", "Chyba", JOptionPane.ERROR_MESSAGE);
        }

    }

    public void ulozGrafJakoXlsx(String nazevSouboruSCestou) {
        try {
            Workbook sesit = new XSSFWorkbook();
            Sheet list = sesit.createSheet("List1");

            list.setDefaultColumnWidth(3);
            list.setDefaultRowHeightInPoints(24);

            CellStyle stylBunky = sesit.createCellStyle();
            stylBunky.setAlignment(HorizontalAlignment.CENTER);
            stylBunky.setVerticalAlignment(VerticalAlignment.CENTER);
            stylBunky.setBorderTop(BorderStyle.THIN);
            stylBunky.setBorderRight(BorderStyle.THIN);
            stylBunky.setBorderBottom(BorderStyle.THIN);
            stylBunky.setBorderLeft(BorderStyle.THIN);

            CellStyle stylBunkyZvlastni = sesit.createCellStyle();
            stylBunkyZvlastni.setAlignment(HorizontalAlignment.CENTER);
            stylBunkyZvlastni.setVerticalAlignment(VerticalAlignment.CENTER);
            stylBunkyZvlastni.setFillForegroundColor(IndexedColors.BLACK.getIndex());
            stylBunkyZvlastni.setFillPattern(FillPatternType.SOLID_FOREGROUND);
            stylBunkyZvlastni.setBorderTop(BorderStyle.THIN);
            stylBunkyZvlastni.setBorderRight(BorderStyle.THIN);
            stylBunkyZvlastni.setBorderBottom(BorderStyle.THIN);
            stylBunkyZvlastni.setBorderLeft(BorderStyle.THIN);

            CellStyle stylBunkyOznaceniUzluGrafu = sesit.createCellStyle();
            Font font = sesit.createFont();
            font.setBold(true);
            stylBunkyOznaceniUzluGrafu.setFont(font);
            stylBunkyOznaceniUzluGrafu.setAlignment(HorizontalAlignment.CENTER);
            stylBunkyOznaceniUzluGrafu.setVerticalAlignment(VerticalAlignment.CENTER);
            stylBunkyOznaceniUzluGrafu.setFillForegroundColor(IndexedColors.GREY_25_PERCENT.getIndex());
            stylBunkyOznaceniUzluGrafu.setFillPattern(FillPatternType.SOLID_FOREGROUND);
            stylBunkyOznaceniUzluGrafu.setBorderTop(BorderStyle.THIN);
            stylBunkyOznaceniUzluGrafu.setBorderRight(BorderStyle.THIN);
            stylBunkyOznaceniUzluGrafu.setBorderBottom(BorderStyle.THIN);
            stylBunkyOznaceniUzluGrafu.setBorderLeft(BorderStyle.THIN);

            int pomocnyPocetRadku = 0;
            for (int i = 0; i < kolekceGrafu.size(); i = i + 1) {

                for (int indexRadkuVGrafu = 0; indexRadkuVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexRadkuVGrafu = indexRadkuVGrafu + 1) {
                    if (indexRadkuVGrafu == 0) { //i == 0, tzn. jsme na prvním řádku
                        Row radek = list.createRow(pomocnyPocetRadku);
                        pomocnyPocetRadku = pomocnyPocetRadku + 1;
                        for (int indexSloupceVGrafu = 0; indexSloupceVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexSloupceVGrafu = indexSloupceVGrafu + 1) {

                            if (indexSloupceVGrafu == 0) { //první sloupec
                                radek.createCell(indexSloupceVGrafu).setCellValue("");
                                radek.getCell(indexSloupceVGrafu).setCellStyle(stylBunkyZvlastni);
                            } else { //každý další sloupec
                                switch (typZnaceniVrcholu) {
                                    case 0:
                                        char oznaceniVrcholuCase0 = 'a';
                                        oznaceniVrcholuCase0 += (indexSloupceVGrafu - 1);
                                        radek.createCell(indexSloupceVGrafu).setCellValue(String.valueOf(oznaceniVrcholuCase0));
                                        radek.getCell(indexSloupceVGrafu).setCellStyle(stylBunkyOznaceniUzluGrafu);
                                        break;
                                    case 1:
                                        char oznaceniVrcholuCase1 = 'A';
                                        oznaceniVrcholuCase1 += (indexSloupceVGrafu - 1);
                                        radek.createCell(indexSloupceVGrafu).setCellValue(String.valueOf(oznaceniVrcholuCase1));
                                        radek.getCell(indexSloupceVGrafu).setCellStyle(stylBunkyOznaceniUzluGrafu);
                                        break;
                                    case 2:
                                        int oznaceniVrcholuCase2 = 0;
                                        oznaceniVrcholuCase2 += indexSloupceVGrafu;
                                        radek.createCell(indexSloupceVGrafu).setCellValue(oznaceniVrcholuCase2);
                                        radek.getCell(indexSloupceVGrafu).setCellStyle(stylBunkyOznaceniUzluGrafu);
                                        break;
                                }
                            }

                        }
                    } else { //i != 0, tzn. nejsme na prvním řádku
                        Row dalsiRadek = list.createRow(pomocnyPocetRadku);
                        pomocnyPocetRadku = pomocnyPocetRadku + 1;
                        for (int indexSloupceVGrafu = 0; indexSloupceVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexSloupceVGrafu = indexSloupceVGrafu + 1) {

                            if (indexSloupceVGrafu == 0) { //první sloupec
                                switch (typZnaceniVrcholu) {
                                    case 0:
                                        char oznaceniVrcholuCase0 = 'a';
                                        oznaceniVrcholuCase0 += (indexRadkuVGrafu - 1);
                                        dalsiRadek.createCell(indexSloupceVGrafu).setCellValue(String.valueOf(oznaceniVrcholuCase0));
                                        dalsiRadek.getCell(indexSloupceVGrafu).setCellStyle(stylBunkyOznaceniUzluGrafu);
                                        break;
                                    case 1:
                                        char oznaceniVrcholuCase1 = 'A';
                                        oznaceniVrcholuCase1 += (indexRadkuVGrafu - 1);
                                        dalsiRadek.createCell(indexSloupceVGrafu).setCellValue(String.valueOf(oznaceniVrcholuCase1));
                                        dalsiRadek.getCell(indexSloupceVGrafu).setCellStyle(stylBunkyOznaceniUzluGrafu);
                                        break;
                                    case 2:
                                        int oznaceniVrcholuCase2 = 0;
                                        oznaceniVrcholuCase2 += indexRadkuVGrafu;
                                        dalsiRadek.createCell(indexSloupceVGrafu).setCellValue(oznaceniVrcholuCase2);
                                        dalsiRadek.getCell(indexSloupceVGrafu).setCellStyle(stylBunkyOznaceniUzluGrafu);
                                        break;
                                }
                            } else { //každý další sloupec
                                dalsiRadek.createCell(indexSloupceVGrafu).setCellValue(kolekceGrafu.get(i).getPrvek(indexRadkuVGrafu - 1, indexSloupceVGrafu - 1));
                                dalsiRadek.getCell(indexSloupceVGrafu).setCellStyle(stylBunky);
                            }

                        }
                    }
                }
                pomocnyPocetRadku = pomocnyPocetRadku + 1;
            }

            FileOutputStream vystup = new FileOutputStream(new File(nazevSouboruSCestou + ".xlsx"));
            sesit.write(vystup);
            vystup.close();
            sesit.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Uložení výstupu se nezdařilo.", "Chyba", JOptionPane.ERROR_MESSAGE);
        }

    }

    public void ulozGrafJakoCsv(String nazevSouboruSCestou) {
        try {
            PrintWriter printWriter = new PrintWriter(new FileWriter(nazevSouboruSCestou + ".csv"/*format*/));
            String radek = "sep = ;\n";

            for (int i = 0; i < kolekceGrafu.size(); i = i + 1) {

                for (int indexRadkuVGrafu = 0; indexRadkuVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexRadkuVGrafu = indexRadkuVGrafu + 1) {
                    if (indexRadkuVGrafu == 0) { //i == 0, tzn. jsme na prvním řádku
                        for (int indexSloupceVGrafu = 0; indexSloupceVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexSloupceVGrafu = indexSloupceVGrafu + 1) {
                            if (indexSloupceVGrafu == 0) { //první sloupec
                                radek = radek + ";";
                            } else { //každý další sloupec
                                switch (typZnaceniVrcholu) {
                                    case 0:
                                        char oznaceniVrcholuCase0 = 'a';
                                        oznaceniVrcholuCase0 += (indexSloupceVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase0) + ";";
                                        break;
                                    case 1:
                                        char oznaceniVrcholuCase1 = 'A';
                                        oznaceniVrcholuCase1 += (indexSloupceVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase1) + ";";
                                        break;
                                    case 2:
                                        int oznaceniVrcholuCase2 = 0;
                                        oznaceniVrcholuCase2 += indexSloupceVGrafu;
                                        radek = radek + String.valueOf(oznaceniVrcholuCase2) + ";";
                                        break;
                                }
                            }
                        }
                    } else { //i != 0, tzn. nejsme na prvním řádku
                        for (int indexSloupceVGrafu = 0; indexSloupceVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexSloupceVGrafu = indexSloupceVGrafu + 1) {
                            if (indexSloupceVGrafu == 0) { //první sloupec
                                switch (typZnaceniVrcholu) {
                                    case 0:
                                        char oznaceniVrcholuCase0 = 'a';
                                        oznaceniVrcholuCase0 += (indexRadkuVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase0) + ";";
                                        break;
                                    case 1:
                                        char oznaceniVrcholuCase1 = 'A';
                                        oznaceniVrcholuCase1 += (indexRadkuVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase1) + ";";
                                        break;
                                    case 2:
                                        int oznaceniVrcholuCase2 = 0;
                                        oznaceniVrcholuCase2 += indexRadkuVGrafu;
                                        radek = radek + String.valueOf(oznaceniVrcholuCase2) + ";";
                                        break;
                                }
                            } else { //každý další sloupec
                                radek = radek + String.valueOf(kolekceGrafu.get(i).getPrvek(indexRadkuVGrafu - 1, indexSloupceVGrafu - 1)) + ";";
                            }
                        }
                    }
                    printWriter.println(radek);
                    radek = "";
                }
                printWriter.println(radek);
            }

            printWriter.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(null, "Uložení výstupu se nezdařilo.", "Chyba", JOptionPane.ERROR_MESSAGE);
        }

    }

    public void ulozGrafJakoTxt(String nazevSouboruSCestou) {
        try {
            PrintWriter printWriter = new PrintWriter(new FileWriter(nazevSouboruSCestou + ".txt"/*format*/));
            String radek = "";

            for (int i = 0; i < kolekceGrafu.size(); i = i + 1) {

                for (int indexRadkuVGrafu = 0; indexRadkuVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexRadkuVGrafu = indexRadkuVGrafu + 1) {
                    if (indexRadkuVGrafu == 0) { //i == 0, tzn. jsme na prvním řádku
                        for (int indexSloupceVGrafu = 0; indexSloupceVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexSloupceVGrafu = indexSloupceVGrafu + 1) {
                            if (indexSloupceVGrafu == 0) { //první sloupec
                                radek = radek + "\t";
                            } else { //každý další sloupec
                                switch (typZnaceniVrcholu) {
                                    case 0:
                                        char oznaceniVrcholuCase0 = 'a';
                                        oznaceniVrcholuCase0 += (indexSloupceVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase0) + "\t";
                                        break;
                                    case 1:
                                        char oznaceniVrcholuCase1 = 'A';
                                        oznaceniVrcholuCase1 += (indexSloupceVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase1) + "\t";
                                        break;
                                    case 2:
                                        int oznaceniVrcholuCase2 = 0;
                                        oznaceniVrcholuCase2 += indexSloupceVGrafu;
                                        radek = radek + String.valueOf(oznaceniVrcholuCase2) + "\t";
                                        break;
                                }
                            }
                        }
                    } else { //i != 0, tzn. nejsme na prvním řádku
                        for (int indexSloupceVGrafu = 0; indexSloupceVGrafu < kolekceGrafu.get(i).getPocetUzlu() + 1; indexSloupceVGrafu = indexSloupceVGrafu + 1) {
                            if (indexSloupceVGrafu == 0) { //první sloupec
                                switch (typZnaceniVrcholu) {
                                    case 0:
                                        char oznaceniVrcholuCase0 = 'a';
                                        oznaceniVrcholuCase0 += (indexRadkuVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase0) + "\t";
                                        break;
                                    case 1:
                                        char oznaceniVrcholuCase1 = 'A';
                                        oznaceniVrcholuCase1 += (indexRadkuVGrafu - 1);
                                        radek = radek + String.valueOf(oznaceniVrcholuCase1) + "\t";
                                        break;
                                    case 2:
                                        int oznaceniVrcholuCase2 = 0;
                                        oznaceniVrcholuCase2 += indexRadkuVGrafu;
                                        radek = radek + String.valueOf(oznaceniVrcholuCase2) + "\t";
                                        break;
                                }
                            } else { //každý další sloupec
                                radek = radek + String.valueOf(kolekceGrafu.get(i).getPrvek(indexRadkuVGrafu - 1, indexSloupceVGrafu - 1)) + "\t";
                            }
                        }
                    }
                    printWriter.println(radek);
                    radek = "";
                }
                printWriter.println(radek);
            }

            printWriter.close();
        } catch (Exception e) {
            JOptionPane.showMessageDialog(frame, "Uložení výstupu se nezdařilo.", "Chyba", JOptionPane.ERROR_MESSAGE);
        }
    }

}
