package gui;

import java.awt.Color;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableColumn;

import model.GrafTableModel;

public class TabulkaProGraf extends JTable {

    private int vyskaASirkaTabulky;

    public TabulkaProGraf(GrafTableModel grafTableModel, int velikostPisma, int vyskaASirkaTabulky) {
        super();
        this.vyskaASirkaTabulky = vyskaASirkaTabulky;
        setModel(grafTableModel);
        setGridColor(Color.BLACK);
        setBorder(BorderFactory.createLineBorder(Color.BLACK));
        setCellSelectionEnabled(false);
        setFocusable(false);
        setFont(new Font("Dialog", Font.PLAIN, velikostPisma));
    }

    public void vycentrujHodnotyVTabulce() {
        setRowHeight(vyskaASirkaTabulky);

        DefaultTableCellRenderer centerRenderer = new DefaultTableCellRenderer();
        centerRenderer.setHorizontalAlignment(SwingConstants.CENTER);

        DefaultTableCellRenderer centerRendererPlus = new DefaultTableCellRenderer();
        centerRendererPlus.setHorizontalAlignment(SwingConstants.CENTER);
        centerRendererPlus.setFont(new Font("Dialog", Font.PLAIN, 20));

        for (int i = 0; i < getColumnCount(); i = i + 1) {
            TableColumn column = getColumnModel().getColumn(i);
            column.setMaxWidth(vyskaASirkaTabulky);
            getColumnModel().getColumn(i).setCellRenderer(centerRenderer);
        }
    }

    public int getVyskaASirkaTabulky() {
        return vyskaASirkaTabulky;
    }

    public void setVyskaASirkaTabulky(int vyskaASirkaTabulky) {
        this.vyskaASirkaTabulky = vyskaASirkaTabulky;
    }

}
