package gui;

import java.awt.BorderLayout;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import model.Graf;
import model.GrafTableModel;

public class VychodniPanel extends JPanel {

    private JScrollPane scrollPaneProVychodniPanel;

    private JPanel panelProGrafy;

    public VychodniPanel(List<Graf> kolekceGrafu, Graf aktualneVygenerovanyGraf, List<TabulkaProGraf> kolekceTabulek, DialogNastaveni nastavovaciDialog) {
        super();
        scrollPaneProVychodniPanel = new JScrollPane(this);
        scrollPaneProVychodniPanel.getVerticalScrollBar().setUnitIncrement(10); //nastavení "rychlosti" scrollování

        setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        //přidání prvního záznamu do kolekce - "inicializační graf"
        kolekceGrafu.add(aktualneVygenerovanyGraf);
        TabulkaProGraf tabulkaProZobrazeniGrafu = new TabulkaProGraf(new GrafTableModel(kolekceGrafu.get(0), 0), 12, 25);
        tabulkaProZobrazeniGrafu.vycentrujHodnotyVTabulce();
        kolekceTabulek.add(tabulkaProZobrazeniGrafu);

        panelProGrafy = new JPanel();
        panelProGrafy.setLayout(new BoxLayout(panelProGrafy, BoxLayout.Y_AXIS));
        panelProGrafy.setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
        panelProGrafy.add(tabulkaProZobrazeniGrafu);
        add(panelProGrafy, BorderLayout.NORTH);
    }

    public JPanel getPanelProGrafy() {
        return panelProGrafy;
    }

    public JScrollPane getScrollPaneProVychodniPanel() {
        return scrollPaneProVychodniPanel;
    }

}
