package gui;

import java.awt.Color;
import java.util.ArrayList;
import java.util.List;
import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

public class ZapadniPanel extends JPanel {

    private JScrollPane scrollPaneProZapadniPanel;

    private PanelPocetGrafuJednohoTypu panelPocetGrafuJednohoTypu;
    private List<KostraZadaniGrafu> seznamKoster;
    private PanelGenerovatGraf panelGenerovatGraf;

    public ZapadniPanel() {
        super();
        setBorder(BorderFactory.createEmptyBorder(15, 15, 15, 15));
        setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

        scrollPaneProZapadniPanel = new JScrollPane(this);
        scrollPaneProZapadniPanel.getVerticalScrollBar().setUnitIncrement(10);

        panelPocetGrafuJednohoTypu = new PanelPocetGrafuJednohoTypu();
        seznamKoster = new ArrayList<>();
        panelGenerovatGraf = new PanelGenerovatGraf();

        inicializujSe();

    }

    public JScrollPane getScrollPaneProZapadniPanel() {
        return scrollPaneProZapadniPanel;
    }

    public void inicializujSe() {
        pridejPanelPocetGrafuJednohoTypu();
        seznamKoster.add(new KostraZadaniGrafu());
        for (int i = 0; i < seznamKoster.size(); i = i + 1) {
            seznamKoster.get(i).setBorder(BorderFactory.createTitledBorder(BorderFactory.createLineBorder(Color.BLACK), "Graf:"));
            add(seznamKoster.get(i));
        }
        pridejPanelGenerovatGraf();
    }

    public void pridejPanelPocetGrafuJednohoTypu() {
        add(panelPocetGrafuJednohoTypu);
    }

    public void pridejPanelGenerovatGraf() {
        add(panelGenerovatGraf);
    }

    public PanelPocetGrafuJednohoTypu getPanelPocetGrafuJednohoTypu() {
        return panelPocetGrafuJednohoTypu;
    }

    public List<KostraZadaniGrafu> getSeznamKoster() {
        return seznamKoster;
    }

    public PanelGenerovatGraf getPanelGenerovatGraf() {
        return panelGenerovatGraf;
    }

}
