package model;

import javax.swing.table.AbstractTableModel;

public class GrafTableModel extends AbstractTableModel {

    private Graf graf;
    private int typZnaceniVrcholu;

    public GrafTableModel(Graf graf, int typZnaceniVrcholu) {
        super();
        this.graf = graf;
        this.typZnaceniVrcholu = typZnaceniVrcholu;
    }

    @Override
    public int getRowCount() {
        return (graf.getPocetUzlu() + 1);
    }

    @Override
    public int getColumnCount() {
        return (graf.getPocetUzlu() + 1);
    }

    @Override
    public String getColumnName(int indexSloupce) {

        switch (typZnaceniVrcholu) {
            case 0:
                char oznaceniVrcholuCase0 = 'a';
                oznaceniVrcholuCase0 += (indexSloupce - 1);
                return String.valueOf(oznaceniVrcholuCase0);
            case 1:
                char oznaceniVrcholuCase1 = 'A';
                oznaceniVrcholuCase1 += (indexSloupce - 1);
                return String.valueOf(oznaceniVrcholuCase1);
            case 2:
                int oznaceniVrcholuCase2 = 0;
                oznaceniVrcholuCase2 += indexSloupce;
                return String.valueOf(oznaceniVrcholuCase2);
            default:
                return null;
        }
    }

    @Override
    public Object getValueAt(int indexRadku, int indexSloupce) {
        if (indexRadku == 0) { //první řádek
            if (indexSloupce == 0) { //první sloupec v prním řádku
                return String.valueOf("");
            } else {
                switch (typZnaceniVrcholu) {
                    case 0:
                        char oznaceniVrcholuCase0 = 'a';
                        oznaceniVrcholuCase0 += (indexSloupce - 1);
                        return String.valueOf(oznaceniVrcholuCase0);
                    case 1:
                        char oznaceniVrcholuCase1 = 'A';
                        oznaceniVrcholuCase1 += (indexSloupce - 1);
                        return String.valueOf(oznaceniVrcholuCase1);
                    case 2:
                        int oznaceniVrcholuCase2 = 0;
                        oznaceniVrcholuCase2 += indexSloupce;
                        return String.valueOf(oznaceniVrcholuCase2);
                    default:
                        return null;
                }
            }

        } else { //všechny ostatní řádky
            if (indexSloupce == 0) { //první sloupec v každém ostatním řádku;
                switch (typZnaceniVrcholu) {
                    case 0:
                        char oznaceniVrcholuCase0 = 'a';
                        oznaceniVrcholuCase0 += (indexRadku - 1);
                        return String.valueOf(oznaceniVrcholuCase0);
                    case 1:
                        char oznaceniVrcholuCase1 = 'A';
                        oznaceniVrcholuCase1 += (indexRadku - 1);
                        return String.valueOf(oznaceniVrcholuCase1);
                    case 2:
                        int oznaceniVrcholuCase2 = 0;
                        oznaceniVrcholuCase2 += indexRadku;
                        return String.valueOf(oznaceniVrcholuCase2);
                    default:
                        return null;
                }
            } else { //všechny ostatní sloupce ve všech ostatních řádcích
                return String.valueOf(graf.getPrvek(indexRadku - 1, indexSloupce - 1));
            }

        }

    }

    @Override
    public boolean isCellEditable(int radek, int sloupec) {
        return false;
    }

    public void refresh() {
        fireTableDataChanged();
    }

}
